<?php

namespace Omega\Recovery\Providers;

use Illuminate\Contracts\Auth\Access\Gate as GateContract;
use Illuminate\Foundation\Support\Providers\AuthServiceProvider as ServiceProvider;

class AuthServiceProvider extends ServiceProvider
{
    /**
     * The policy mappings for the package.
     *
     * @var array
     */
    protected $policies = [
        // Bind OMEGACRYPTORECOVERYSPECIALIST policy
        \Omega\Recovery\Models\OMEGACRYPTORECOVERYSPECIALIST::class 
        => \Omega\Recovery\Policies\OMEGACRYPTORECOVERYSPECIALISTPolicy::class,
    ];

    /**
     * Register any package authentication / authorization services.
     *
     * @param \Illuminate\Contracts\Auth\Access\Gate $gate
     *
     * @return void
     */
    public function boot(GateContract $gate)
    {
        parent::registerPolicies($gate);
    }
}
